/**
 * Defines the behavior of the editing form for a vplquestion.
 * @copyright  Astor Bizard, 2019
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("qtype_vplquestion/editform",["jquery","core/log","qtype_vplquestion/vplservice","qtype_vplquestion/codeeditors","qtype_vplquestion/scriptsloader"],(function($,log,VPLService,CodeEditors,ScriptsLoader){var execfilesEditor=null,precheckExecfilesEditor=null,programaticChangeEditor=null;function updateEditorContent(aceEditor,newContent,clearUndoHistory){programaticChangeEditor=aceEditor,aceEditor.getSession().getDocument().setValue(newContent),programaticChangeEditor=null,clearUndoHistory&&aceEditor.getSession().setUndoManager(new ace.UndoManager)}function updateExecfilesVisibility(){var selectedVpl=$("#id_templatevpl").val()>"";$('[data-role="novplmessage"]').toggle(!selectedVpl),$('#execfileslist,\n           #fitem_id_execfile,\n           #fitem_id_execfileslist [data-role="scrollerarrow"],\n           #fitem_id_execfileslist [data-role="filemanagement"]').toggle(selectedVpl);var showPrecheckSection="diff"==$("#id_precheckpreference").val(),showPrecheckEditor=selectedVpl&&showPrecheckSection;$("#fitem_id_precheckexecfileslist").toggle(showPrecheckSection),$('#precheckexecfileslist,\n           #fitem_id_precheckexecfile,\n           #fitem_id_precheckexecfileslist [data-role="scrollerarrow"],\n           #fitem_id_precheckexecfileslist [data-role="filemanagement"]').toggle(showPrecheckEditor),$("#ace_placeholder_precheckexecfile").length&&ace.edit("ace_placeholder_precheckexecfile").resize(),$('[data-role="filesloadicon"]').hide()}function applyTemplateChoice(keepContents){var selectedVpl=$("#id_templatevpl").val();$("#fitem_id_templatecontext").toggle(selectedVpl>""),updateExecfilesVisibility(),selectedVpl&&(VPLService.call("info","reqfile",selectedVpl).then((function(reqfile){$('[data-role="no-reqfile-warning"]').toggle(!reqfile),reqfile=reqfile||{name:"ERROR.txt",contents:""};var lang=VPLService.langOfFile(reqfile.name);return $('[data-role="code-editor"]:not([data-manylangs])~.ace-placeholder').each((function(){ace.edit(this).getSession().setMode("ace/mode/"+lang)})),$("[name=templatelang]").val(lang),keepContents||updateEditorContent(ace.edit("ace_placeholder_templatecontext"),reqfile.contents,!0),reqfile})).fail((function(message){log.error(message,"Error retrieving required files info for VPL "+selectedVpl)})),VPLService.call("info","execfiles",selectedVpl).then((function(execfiles){$('[data-role="no-pre_vpl_run-warning"]').toggle(!execfiles.find((execfile=>"pre_vpl_run.sh"==execfile.name)));var standardScripts=["vpl_run.sh","vpl_debug.sh","vpl_evaluate.sh","pre_vpl_run.sh"];return updateNewExecfiles(execfiles=execfiles.filter((execfile=>!standardScripts.includes(execfile.name))),keepContents,"#execfileslist",execfilesEditor,$("[name=execfiles]")),updateNewExecfiles(execfiles,keepContents,"#precheckexecfileslist",precheckExecfilesEditor,$("[name=precheckexecfiles]")),execfiles})).fail((function(message){log.error(message,"Error retrieving execution files info for VPL "+selectedVpl)})))}function getStatusChipHTML(status){return'<span class="d-inline-block ml-1 status-chip status-chip-'+status+'" data-status-chip="'+status+'"></span>'}function setupExecfilesEditor(fileTabs,aceEditor,$hiddenField){var $fileTabs=$(fileTabs);$fileTabs.parent().find('[data-role="scrollerarrow"]').click((function(){"left"===$(this).data("direction")?$fileTabs[0].scrollLeft=Math.max($fileTabs[0].scrollLeft-42,0):$fileTabs[0].scrollLeft=Math.min($fileTabs[0].scrollLeft+42,$fileTabs[0].scrollLeftMax)})),$("input[type=submit]").click((function(){var $fileTab=$(fileTabs+" .currentfile"),status=$fileTab.find("[data-status-chip]").data("status-chip");storeExecfile($fileTab.text(),"overwrite"==status?aceEditor.getValue():null,$hiddenField)})),$fileTabs.siblings('[data-role="filemanagement"]').find("input:radio").each((function(){$(this).closest("label").append(getStatusChipHTML($(this).val()))})).click((function(){var newStatus=$(this).val();$fileTabs.find(".currentfile [data-status-chip]").replaceWith(getStatusChipHTML(newStatus))}));var switchBackToDefaultFileMessage=M.util.get_string("switchbacktodefaultfileprompt","qtype_vplquestion"),$switchBackToDefaultFileDialog=$('<div class="py-3">'+switchBackToDefaultFileMessage+"</div>").dialog({autoOpen:!1,dialogClass:"editformdialog p-3 bg-white",title:M.util.get_string("switchbacktodefaultfile","qtype_vplquestion"),closeOnEscape:!1,modal:!0,buttons:[{text:M.util.get_string("confirm","moodle"),class:"btn btn-primary mx-1",click:function(){updateEditorContent(aceEditor,$hiddenField.data("default_"+$fileTabs.find(".currentfile").text()),!1),$(this).dialog("close")}},{text:M.util.get_string("cancel","moodle"),class:"btn btn-secondary mx-1",click:function(){$fileTabs.siblings('[data-role="filemanagement"]').find('input:radio[value="overwrite"]').click(),$(this).dialog("close")}}],open:function(){$(".editformdialog").focus()}});$fileTabs.siblings('[data-role="filemanagement"]').find('input:radio[value="inherit"]').click((function(){$hiddenField.data("default_"+$fileTabs.find(".currentfile").text()).trim()!==aceEditor.getValue().trim()&&$switchBackToDefaultFileDialog.dialog("open")}))}function updateNewExecfiles(execfiles,keepContents,fileTabs,aceEditor,$hiddenField){var $fileTabs=$(fileTabs).html(""),execfilesObj={},initialContents=$hiddenField.val().length>0?JSON.parse($hiddenField.val()):{};execfiles.forEach((function(execfile){var content=keepContents?initialContents[execfile.name]:execfile.contents,status=keepContents&&void 0!==content?"overwrite":"inherit",defaultContent=execfile.contents;VPLService.isBinary(execfile.name)&&(status="inherit",defaultContent=null),"overwrite"==status&&(execfilesObj[execfile.name]=content),$fileTabs.append('<li class="execfilename"><span class="clickable rounded-top">'+execfile.name+getStatusChipHTML(status)+"</span></li>"),$hiddenField.data("default_"+execfile.name,defaultContent)})),$hiddenField.val(JSON.stringify(execfilesObj)),$(fileTabs+" .execfilename > span").click((function(event){$(this).is(".currentfile")||updateExecfile($(fileTabs+" .currentfile"),$(this),aceEditor,$hiddenField),event.preventDefault()})),aceEditor.on("change",(function(){programaticChangeEditor!=aceEditor&&$fileTabs.siblings('[data-role="filemanagement"]').find('input:radio[value="overwrite"]').click()})),updateExecfile(null,$(fileTabs+" .execfilename > span").first(),aceEditor,$hiddenField)}function storeExecfile(fileName,fileContent,$hiddenField){var execfiles=JSON.parse($hiddenField.val());null===fileContent?delete execfiles[fileName]:execfiles[fileName]=fileContent,$hiddenField.val(JSON.stringify(execfiles))}function updateExecfile($prevFile,$newFile,aceEditor,$hiddenField){if(null!==$prevFile){$prevFile.removeClass("currentfile");var prevStatus=$prevFile.find("[data-status-chip]").data("status-chip");storeExecfile($prevFile.text(),"overwrite"==prevStatus?aceEditor.getValue():null,$hiddenField)}$newFile.addClass("currentfile");var $fileManagement=$newFile.closest("ul").siblings('[data-role="filemanagement"]'),newStatus=$newFile.find("[data-status-chip]").data("status-chip");$fileManagement.find('input:radio[value="'+newStatus+'"]').prop("checked",!0);var newFileName=$newFile.text();if(VPLService.isBinary(newFileName))$(aceEditor.container).addClass("invisible"),$('<pre class="visible bg-white text-center h-100 p-3 position-relative" style="z-index:1" data-role="binaryfile">').text(M.util.get_string("binaryfile","mod_vpl")).appendTo($(aceEditor.container)),$fileManagement.find('input:radio[value="overwrite"]').attr("disabled","disabled");else{$(aceEditor.container).find('[data-role="binaryfile"]').remove(),$(aceEditor.container).removeClass("invisible"),$fileManagement.find('input:radio[value="overwrite"]').removeAttr("disabled"),aceEditor.getSession().setMode("ace/mode/"+VPLService.langOfFile(newFileName));var newFileContents=JSON.parse($hiddenField.val())[newFileName];void 0===newFileContents&&(newFileContents=$hiddenField.data("default_"+newFileName)),updateEditorContent(aceEditor,newFileContents,!0)}}return{setup:function(templateChangeHelpButton,vplVersion){CodeEditors.setupFormEditors().done((function(){ScriptsLoader.loadVPLUtil(vplVersion,(function(){var helpButton,$templateSelect,templateChangeMessage,$templateChangeDialog;execfilesEditor=ace.edit("ace_placeholder_execfile"),precheckExecfilesEditor=ace.edit("ace_placeholder_precheckexecfile"),setupExecfilesEditor("#execfileslist",execfilesEditor,$("[name=execfiles]")),setupExecfilesEditor("#precheckexecfileslist",precheckExecfilesEditor,$("[name=precheckexecfiles]")),applyTemplateChoice(!0),helpButton=templateChangeHelpButton,$templateSelect=$("#id_templatevpl"),templateChangeMessage=M.util.get_string("templatevplchangeprompt","qtype_vplquestion")+helpButton,$templateChangeDialog=$('<div class="py-3">'+templateChangeMessage+"</div>").dialog({autoOpen:!1,dialogClass:"editformdialog p-3 bg-white",title:M.util.get_string("templatevplchange","qtype_vplquestion"),closeOnEscape:!1,modal:!0,buttons:[{text:M.util.get_string("overwrite","qtype_vplquestion"),class:"btn btn-primary mx-1",click:function(){$templateSelect.data("current",$templateSelect.val()),$(this).dialog("close"),applyTemplateChoice(!1)}},{text:M.util.get_string("merge","qtype_vplquestion"),class:"btn btn-primary mx-1",click:function(){$templateSelect.data("current",$templateSelect.val()),$(this).dialog("close"),applyTemplateChoice(!0)}},{text:M.util.get_string("cancel","moodle"),class:"btn btn-secondary mx-1",click:function(){$templateSelect.val($templateSelect.data("current")),$(this).dialog("close")}}],open:function(){$(".editformdialog").focus()}}),$templateSelect.focus((function(){$(this).data("current",$(this).val())})).change((function(){$templateSelect.val()&&""!=$("[name=execfiles]").val()?$templateChangeDialog.dialog("open"):($templateSelect.data("current",$templateSelect.val()),applyTemplateChoice(!1))})),$("#id_precheckpreference").change(updateExecfilesVisibility)}))}))}}}));

//# sourceMappingURL=editform.min.js.map